//Author: Emil Indzhev
#include <iostream>
#include <cstdint>
#include <cassert>

const uint32_t MAX_N = 1e5 + 12;
const uint64_t MAX_H = 1e13;

int32_t h[MAX_N];
uint32_t n;
int64_t eGained, eLost;

void input() {
	std::cin >> n;
	for (uint32_t i = 0;i < n;i++) {
		std::cin >> h[i];
	}
	std::cin >> eGained >> eLost;
}

bool changed = false;

int64_t solve_autism() {
	int64_t energy = h[0] * eGained;
	int64_t ans = 0;
	for (uint32_t i = 1;i < n;i++) {
		int64_t maxH = energy / eLost;
		if (maxH < h[i]) {
			ans += h[i] - maxH;
			if (i < n - 1) {
				changed = true;
			}
			h[i] = maxH;
		}
		energy -= h[i] * eLost;
		energy += h[i] * eGained;
	}
	return ans;

}

int64_t solve_norm() {
	int64_t maxEPrev = 0;
	int64_t maxEPost = 0;
	uint32_t maxInd = 0;
	int64_t maxE = 0;

	int64_t curE = 0;
	assert(n > 2);
	for (uint32_t i = 1;i + 1 < n;i++) {
		curE += h[i] * eLost;
		if (curE > maxE) {
			maxEPrev = maxE;
			maxE = curE;
			maxEPost = 0;
			maxInd = i;
		} else if (curE > maxEPost) {
			maxEPost = curE;
		}
		curE -= h[i] * eGained;
	}

	int64_t tHight = (maxE + eGained - 1) / eGained;
	if (tHight < h[0]) {
		tHight = h[0];
	}

	int64_t bl = h[0] - 1;
	int64_t rDelta = 0;
	int64_t bh = tHight;

	/*
	while (bh - bl > 1) {
		int64_t med = (bh + bl + 1) / 2;
		int64_t sE = med * eGained;
		bool ok = true;
		if (sE < maxEPrev) {
			ok = false;
		}
		int64_t reqDelta = 0;
		if (sE < maxE) {
			reqDelta = (maxE - sE + eLost - 1) / eLost;
		}
		int64_t nE = sE + reqDelta * (eLost - eGained);
		if (nE < maxEPost) {
			ok = false;
		}
		
		if (ok) {
			bh = med;
			rDelta = reqDelta;
		} else {
			bl = med;
		}
	}*/
	h[maxInd] -= rDelta;
	h[0] = bh;
	int64_t ans = bh - h[0] + rDelta + solve_autism();
	assert(!changed);
	return ans;
}

void solve() {
	input();
	int64_t ans = 0;
	if (eLost >= 2 * eGained) {
		ans = solve_autism();
	} else {
		ans = solve_norm();
	}
	std::cout << ans << "\n";

}

int main() {
	std::ios::sync_with_stdio(false);
	std::cin.tie(nullptr);

	uint32_t tCnt;
	std::cin >> tCnt;
	for (uint32_t i = 0;i < tCnt;i++) {
		solve();
	}
}

