//Author: Emil Indzhev
#include <iostream>
#include <cstdint>
#include <cassert>

const uint32_t MAX_N = 1e5 + 12;
const uint64_t MAX_H = 1e13;

int32_t h[MAX_N];
uint32_t n;
int64_t eGained, eLost;

void input() {
	std::cin >> n;
	for (uint32_t i = 0;i < n;i++) {
		std::cin >> h[i];
	}
	std::cin >> eGained >> eLost;
}

bool changed = false;

int64_t solve_autism() {
	int64_t energy = h[0] * eGained;
	int64_t ans = 0;
	for (uint32_t i = 1;i < n;i++) {
		int64_t maxH = energy / eLost;
		int64_t curH = h[i];
		if (maxH < curH) {
			ans += curH - maxH;
			curH = maxH;
		}
		energy -= curH * eLost;
		energy += curH * eGained;
	}
	return ans;

}

int64_t solve_norm() {
	int64_t ans = solve_autism();
	for (uint32_t i = 1;i < 10000;i++) {
		h[0]++;
		int64_t c = solve_autism() + i;
		if (c < ans) {
			ans = c;
		}
	}
	return ans;
}


void solve() {
	input();
	int64_t ans = 0;
	if (eLost >= 2 * eGained) {
		ans = solve_autism();
	} else {
		ans = solve_norm();
	}
	std::cout << ans << "\n";

}

int main() {
	std::ios::sync_with_stdio(false);
	std::cin.tie(nullptr);

	uint32_t tCnt;
	std::cin >> tCnt;
	for (uint32_t i = 0;i < tCnt;i++) {
		solve();
	}
}

