//Author: Emil Indzhev
#include <iostream>
#include <cstdint>
#include <vector>
#include <utility>
#include <cassert>

struct Vertex;

std::pair<Vertex*, Vertex*> remEdge;
bool remed = false;
bool critV = false;

struct Vertex {
	std::vector<Vertex*> edges;
	uint32_t depth;
	uint32_t fixCnt;
	uint32_t fixPrime;
	uint32_t lowest;
	uint32_t minChld;
	uint32_t minOwn;

	std::vector<Vertex*> ownB;
	Vertex *maxOwnV;
	Vertex *par;

	Vertex(): depth(0), fixCnt(0), fixPrime(0), lowest(0), maxOwnV(nullptr), par(nullptr) {}
	uint32_t ind();

	void rem_edge(Vertex *to) {
		for (auto it = edges.begin();it != edges.end();it++) {
			if (*it == to) {
				edges.erase(it);
				return;
			}
		}
		bool rem_non_existing = false;
		assert(rem_non_existing);
	}

	bool possib() {
		if (fixPrime <= 1) {
			lowest = depth;
		}
//		if ((maxOwnV != nullptr) && (maxOwnV->depth >= minChld)) {
//			remEdge = {this, maxOwnV};
//			return true;
//		} else if (ownB.size() >= 2) {
//			Vertex *b = ownB[1]->depth > ownB[0]->depth 
//				? ownB[1] 
//				: ownB[0];
//
//			remEdge = {this, b};
//			return true;

		//std::cerr << "ls " << ind() << " " << lowest << "\n";

		if ((maxOwnV != nullptr) && (maxOwnV->depth >= lowest)) {
			remEdge = {this, maxOwnV};
			return true;
		} else if ((fixPrime > 1) && (par != nullptr) && (par->fixCnt > 1)) {
			remEdge = {this, par};
			return true;
		}
		for (Vertex *v : edges) {
			if (v->depth > depth) {
				v->lowest = lowest;
				if (v->possib()) {
					return true;
				}
			}
		}
		return false;
	}

	uint32_t dfs_1() {
		minChld = depth;
		minOwn = depth;

		for (Vertex *v : edges) {
			if (v->depth == 0) {
				v->depth = depth + 1;
				uint32_t cur = v->dfs_1();
				fixPrime += v->fixPrime;
				if (cur < depth) {
					fixCnt++;
				}
				minChld = std::min(cur, minChld);
			} else if (v->depth + 1 < depth) {
				ownB.push_back(v);
				fixPrime++;
				v->fixPrime--;
				if (v->depth < minOwn) {
					minOwn = v->depth;
				} 
				if ((maxOwnV == nullptr) ||
					(v->depth > maxOwnV->depth)) {
					maxOwnV = v;
				}
			} else {
				par = v;
			}
		}

		//std::cerr << ">>> " << ind() << " " << fixPrime << "\n";
		uint32_t minAll = std::min(minChld, minOwn);
		if ((minAll == depth) && (depth > 1)) {
			critV = true;
		}

		return minAll;
	}

	void dfs_2() {
		for (Vertex *v : edges) {
			assert((this != remEdge.first) || (v != remEdge.second));
			assert((v != remEdge.first) || (this != remEdge.second));
			if (v->depth == 0) {
				std::cout << ind() << " " << v->ind() << "\n";
				v->depth = depth + 1;
				v->dfs_2();
			} else if (v->depth + 1 < depth) {
				std::cout << ind() << " " << v->ind() << "\n";
			}
		}
	}
};

std::vector<Vertex> graph;
std::vector<std::pair<Vertex*, Vertex*>> edges;

uint32_t Vertex::ind() {
	return this - &graph[0] + 1;
}
void input() {
	std::ios::sync_with_stdio(false);
	std::cin.tie(nullptr);

	uint32_t vCnt, eCnt;
	std::cin >> vCnt >> eCnt;
	graph.resize(vCnt);
	for (uint32_t i = 0;i < eCnt;i++) {
		uint32_t a, b;
		std::cin >> a >> b;
		a--;
		b--;
		graph[a].edges.push_back(&graph[b]);
		graph[b].edges.push_back(&graph[a]);
		edges.push_back({&graph[a], &graph[b]});
	}
}


void solve_slow() {
	bool found = false;
	for (auto e : edges) {
		for (Vertex &v : graph) {
			v.depth = 0;
		}
		e.first->rem_edge(e.second);
		e.second->rem_edge(e.first);

		graph[0].depth = 1;
		graph[0].dfs_1();

		if (!critV) {
			found = true;
			std::cout << "2\n";
			std::cout << e.first->ind() << " " << e.second->ind() << "\n";
			break;
		} else {
			e.first->edges.push_back(e.second);
			e.second->edges.push_back(e.first);
		}

	}
	if (!found) {
		std::cout << "1\n";
	}
	for (Vertex &v : graph) {
		v.depth = 0;
	}

	graph[0].depth = 1;
	graph[0].dfs_2();
}


int main() {
	input();
	graph[0].depth = 1;
	graph[0].dfs_1();

	if (critV) {
		std::cout << "0\n";
		return 0;
	} 

	if ((graph.size() < 600) && (edges.size() < 1100)) {
		solve_slow();
		return 0;
	}

	if (graph[0].possib()) {
		std::cout << "2\n";

		std::cout << remEdge.first->ind() << " ";
		std::cout << remEdge.second->ind() << "\n";

		remEdge.first->rem_edge(remEdge.second);
		remEdge.second->rem_edge(remEdge.first);
	} else {
		std::cout << "1\n";
	}
	for (Vertex &v : graph) {
		v.depth = 0;
	}
	graph[0].depth = 1;
	graph[0].dfs_2();
}
