//Author: Emil Indzhev
#include <iostream>
#include <cstdint>

const uint32_t MAX_N = 1e5 + 12;
const uint64_t MAX_H = 1e13;

uint32_t h[MAX_N];
uint32_t n;
uint64_t eGained, eLost;

void input() {
	std::cin >> n;
	for (uint32_t i = 0;i < n;i++) {
		std::cin >> h[i];
	}
	std::cin >> eGained >> eLost;
}

void solve() {
	input();
	uint64_t energy = h[0] * eGained;
	uint64_t ans = 0;
	for (uint32_t i = 1;i < n;i++) {
		uint64_t maxH = energy / eLost;
		if (maxH < h[i]) {
			ans += h[i] - maxH;
			h[i] = maxH;
		}
		energy -= h[i] * eLost;
		energy += h[i] * eGained;
	}
	std::cout << ans << "\n";
}

int main() {
	std::ios::sync_with_stdio(false);
	std::cin.tie(nullptr);

	uint32_t tCnt;
	std::cin >> tCnt;
	for (uint32_t i = 0;i < tCnt;i++) {
		solve();
	}
}

