//Author: Emil Indzhev
#include <iostream>
#include <cstdint>
#include <vector>
#include <utility>
#include <cassert>

struct Vertex;

std::pair<Vertex*, Vertex*> remEdge;
bool remed = false;
bool critV = false;

struct Vertex {
	std::vector<Vertex*> edges;
	uint32_t depth;

	Vertex(): depth(0) {}
	uint32_t ind();

	void rem_edge(Vertex *to) {
		for (auto it = edges.begin();it != edges.end();it++) {
			if (*it == to) {
				edges.erase(it);
				return;
			}
		}
		bool rem_non_existing = false;
		assert(rem_non_existing);
	}

	uint32_t dfs_1() {
		uint32_t minChld = depth;
		uint32_t minOwn = depth;
		std::vector<Vertex*> ownUp;
		//Vertex *minOwnV = nullptr;
		Vertex* par = nullptr;

		for (Vertex *v : edges) {
			if (v->depth == 0) {
				v->depth = depth + 1;
				minChld = std::min(v->dfs_1(), minChld);
			} else if (v->depth + 1 < depth) {
				if (v->depth < minOwn) {
					minOwn = v->depth;
				}
				ownUp.push_back(v);
			} else {
				par = v;
			}
		}

		uint32_t minAll = std::min(minChld, minOwn);
		if ((minAll == depth) && (depth > 1)) {
			critV = true;
			return minAll;
		}
		if ((minChld < depth) && (minOwn < depth) && (!remed)) {
			remed = true;
			if (minOwn < minChld) {
				assert(par != nullptr);
				remEdge = {this, par};
			} else {
				assert(!ownUp.empty());
				remEdge = {this, ownUp.front()};
			}
		}
		if ((ownUp.size() > 1) && (!remed)) {
			remed = true;
			remEdge = {this, ownUp.front()};
		}
		return minAll;
	}

	void dfs_2() {
		for (Vertex *v : edges) {
			if (v->depth == 0) {
				std::cout << ind() << " " << v->ind() << "\n";
				v->depth = depth + 1;
				v->dfs_2();
			} else if (v->depth + 1 < depth) {
				std::cout << ind() << " " << v->ind() << "\n";
			}
		}
	}
};

std::vector<Vertex> graph;

uint32_t Vertex::ind() {
	return this - &graph[0] + 1;
}
void input() {
	std::ios::sync_with_stdio(false);
	std::cin.tie(nullptr);

	uint32_t vCnt, eCnt;
	std::cin >> vCnt >> eCnt;
	graph.resize(vCnt);
	for (uint32_t i = 0;i < eCnt;i++) {
		uint32_t a, b;
		std::cin >> a >> b;
		a--;
		b--;
		graph[a].edges.push_back(&graph[b]);
		graph[b].edges.push_back(&graph[a]);
	}
}

int main() {
	input();
	graph[0].depth = 1;
	graph[0].dfs_1();

	if (critV) {
		std::cout << "0\n";
		return 0;
	} 

	if (remed) {
		std::cout << "2\n";
		std::cout << remEdge.first->ind() << " ";
		std::cout << remEdge.second->ind() << "\n";

		remEdge.first->rem_edge(remEdge.second);
		remEdge.second->rem_edge(remEdge.first);
	} else {
		std::cout << "1\n";
	}
	for (Vertex &v : graph) {
		v.depth = 0;
	}
	graph[0].depth = 1;
	graph[0].dfs_2();
}
