# include <cstdio>
# include <cmath>
# include <algorithm>

using namespace std;

const int MAX_N = 1e6 + 10;
const double eps = 1e-2;

int n, m;

pair <double, double> w[MAX_N];
pair <double, double> c[MAX_N];

double sum[MAX_N];

double dist[MAX_N];

double ans = 1e16;
pair <int, int> ansi;

pair <double, int> f[MAX_N];

int main ()
{
	int i, j, k, t;
	scanf ("%d", &n);
	scanf ("%lf%lf", &w[1].first, &w[1].second);
	for (i = 2; i <= n; i ++)
	{
		scanf ("%lf%lf", &w[i].first, &w[i].second);
		sum[i] = sum[i - 1] 
		+ sqrt ((w[i].first - w[i - 1].first) * (w[i].first - w[i - 1].first)
		+ (w[i].second - w[i - 1].second) * (w[i].second - w[i - 1].second));
	}
	scanf ("%d", &m);
	if (m <= 10000)
		for (i = 1; i <= m; i ++)
			scanf ("%lf%lf", &c[i].first, &c[i].second);
	else
	{
		long long A, B, C, D, P;
		scanf ("%lld%lld%lld%lld%lld", &A, &B, &C, &D, &P);
		c[1] = {A, B};
		for (i = 2; i <= m; i ++)
			c[i] = {((long long) c[i - 1].first * C + D) % P, ((long long) c[i - 1].second * D + C) % P};
	}
	
	for (i = 1; i <= n; i ++)
	{
		for (j = 1; j <= m; j ++)
			dist[i] += 
			(w[i].first - c[j].first) * (w[i].first - c[j].first)
			+ (w[i].second - c[j].second) * (w[i].second - c[j].second);
		
		f[i] = {dist[i], i};
	}	
	
	ansi.first = 1;
	ansi.second = n / 2 + 1;
	
	sort (f + 1, f + n + 1);
	
	for (k = 1; k <= n; k ++)
	{	
	
		i = f[k].second;
		for (t = k - 1; t >= 1; t --)
		{
			if (!(fabs (f[k].first - f[t].first) < eps))
				break;
			j = f[t].second;
			double ad, bd, crr;
			ad = sum[j] - sum[i];
			bd = sum[i] + (sum[n] - sum[j]);
			crr = fabs (ad - bd);
			if (crr < ans)
			{
				ans = crr;
				ansi.first = i;
				ansi.second = j;
			}
		}
	}	
			
	/**
	for (i = 1; i <= n; i ++)
		for (j = i + 1; j <= n; j ++)
			if (fabs (dist[i] - dist[j]) < eps)
			{
				double ad, bd, crr;
				ad = sum[j] - sum[i];
				bd = sum[i] + (sum[n] - sum[j]);
				crr = fabs (ad - bd);
				if (crr < ans)
				{
					ans = crr;
					ansi.first = i;
					ansi.second = j;
				}
			}
	**/
	
	printf ("%.6lf %.6lf\n", w[ansi.first].first, w[ansi.first].second);
	printf ("%.6lf %.6lf\n", w[ansi.second].first, w[ansi.second].second);
		
	
	return 0;
}

