# include <cstdio>
# include <ctime>
# include <vector>
# include <set>
# include <algorithm>

using namespace std;

const int MAX_N = 5e4 + 10;
const int MAX_M = 1e5 + 10;

int n, m;
vector <int> v[MAX_N];

int u[MAX_N], key, cnt;

int nu[MAX_N];
vector <pair <int, int>> ans;

set <pair <int, int>> s;

void dfs (int x)
{
	
	for (; nu[x] < (int) v[x].size (); nu[x] ++)
	{
		if (s.find ({v[x][nu[x]], x}) == s.end ())
		{
			s.insert ({x, v[x][nu[x]]});
			nu[x] ++;
			dfs (v[x][nu[x] - 1]);
			break;
		}
		
	}
}

void dfs_cnt (int x)
{
	u[x] = key;
	cnt ++;
	
	for (int i = 0; i < (int) v[x].size (); i ++)
	{
		if (u[v[x][i]] == key)
			continue;
		if (s.find ({x, v[x][i]}) == s.end ())
			continue;
		dfs_cnt (v[x][i]);
	}
}


int main ()
{
	int i, p, q;
	
	scanf ("%d%d", &n, &m);
	
	for (i = 0; i < m; i ++)
	{
		scanf ("%d%d", &p, &q);
		v[p].push_back (q);
		v[q].push_back (p);
	}
	
	for (i = 1; i <= n; i ++)
	{
		random_shuffle (v[i].begin (), v[i].end ());
		random_shuffle (v[i].begin (), v[i].end ());
		if (v[i].size () <= 1)
		{
			printf ("0\n");
			return 0;
		}
	}
		
		
	bool fl = true;
	
	while (fl)
	{
		fl = false;
		for (i = n; i >= 1; i --)
			if (nu[i] < (int) v[i].size ())
			{
				dfs (i);
				fl = true;
			}
	}
			
	while (clock () < 0.25 * CLOCKS_PER_SEC)
	{
		i = rand () % n + 1;
		cnt = 0;
		key ++;
		dfs_cnt (i);
		if (cnt < n)
		{
			printf ("0\n");
			return 0;
		}
	}
	
	printf ("1\n");
	for (set <pair <int, int>> :: iterator it = s.begin (); it != s.end (); it ++)
		printf ("%d %d\n", (*it).first, (*it).second);
		
	
	return 0;
}

