#include <iostream>
#include <cmath>
#include <iomanip>
#include <vector>
#include <algorithm>
using namespace std;

int n, m;
long double x[(1<<20)], y[(1<<20)], ptsx[(1<<20)], ptsy[(1<<20)];
long double cenX, cenY, lenAll = 0, len0[(1<<20)], th[(1<<20)];

inline long double dist2 ( long double x1, long double y1, long double x2, long double y2 ) {
    return ( x1-x2 )*(x1-x2) + (y1-y2)*(y1-y2);
}
inline long double dist ( long double x1, long double y1, long double x2, long double y2 ) {
    return sqrt( ( x1-x2 )*(x1-x2) + (y1-y2)*(y1-y2) );
}
struct p {
    long double x, y, len0;
    p () {}
    p ( long double x_, long double y_, long double len0_ ) {
        x = x_;
        y = y_;
        len0 = len0_;
    }
};
vector < p > v;

long double minD = (1LL<<42);
long double x1Ans, x2Ans, y1Ans, y2Ans;


bool cmp ( p a, p b ) {
    long double d1 = dist2( a.x, a.y, cenX, cenY );
    long double d2 = dist2( b.x, b.y, cenX, cenY );

    if ( (abs( d1-d2) ) < 0.00000001 ) { return a.len0 < b.len0; }
    return d1 < d2;
}

long double getD ( long double a, long double b ) {
    long double cd = abs( b-a );
    return abs( cd - ( lenAll - cd ) );
}

int main () {

    cout << setprecision( 6 ) << fixed;

    long double cl = (1LL<<60), far = 0;

    cin >> n;
    for ( int i = 0 ; i < n ; i ++ ) {
        cin >> x[i] >> y[i];
    }
    for ( int i = 0 ; i < n ; i ++ ) {
        len0[i] = lenAll;
        lenAll += dist( x[i], y[i], x[(i+1)%n], y[(i+1)%n] );
    }

    cin >> m;
    for ( int i = 0 ; i < m ; i ++ ) {
        cin >> ptsx[i] >> ptsy[i];
        cenX += ptsx[i];
        cenY += ptsy[i];
    }
    cenX /= m;
    cenY /= m;

    for ( int i = 0 ; i < n ; i ++ ) {
        v.push_back( p( x[i], y[i], len0[i] ) );
    }

    sort( v.begin(), v.end(), cmp );

    for ( int i = 0 ; i < n ; ) {

        long double d1 = dist2( v[i].x, v[i].y, cenX, cenY );
        int j = i;
        for ( ; j < n ; j ++ ) {
            long double d2 = dist2( v[j].x, v[j].y, cenX, cenY );
            if ( abs( d2-d1 ) > 0.0000001 ) { break; }
        }


        int last = 0;

        for ( int k = i ; k < j ; k ++ ) {
            for ( int h = i+1 ; h < j ; h ++ ) {
                long double cd = getD( v[k].len0, v[h].len0 );
                if ( cd < minD ) {
                    minD = cd;
                    x1Ans = v[k].x;
                    x2Ans = v[h].x;

                    y1Ans = v[k].y;
                    y2Ans = v[h].y;

                }
            }
        }

        i = j;
    }

//    cout << minD << "\n";

    cout << x1Ans << " " << y1Ans << "\n";
    cout << x2Ans << " " << y2Ans << "\n";

    return 0;
}
