#include<iostream>
#include<iomanip>
#include<unordered_map>
#include<math.h>
#include<vector>
using namespace std;

const int MAX_N=1000100;
const int MAX_M=10100100;
const double EPS=1e-6;

struct Point
{
    long double x, y;
};
Point a[MAX_N],h[MAX_M];
long double eff[MAX_N];
Point ans1,ans2;
int n,m;

unordered_map<long long, vector<int> > bs;

void input()
{
    cin>>n;
    for (int i=0;i<n;++i)
    {
        cin>>a[i].x>>a[i].y;
    }
    int a,b,c,d,p;
    long long x,y;
    cin>>m;
    if (m<10000)
    {
        for (int i=0;i<m;++i)
        {
            cin>>h[i].x>>h[i].y;
        }
    }
    else
    {
        cin>>a>>b>>c>>d>>p;
        x=a;
        y=b;
        for (int i=0;i<m;++i)
        {
            h[i].x=x;
            h[i].y=y;
            x=(x*c+d)%p;
            y=(y*d+c)%p;
        }
    }
}
void output()
{
    cout<<std::fixed;
    cout<<std::setprecision(6);
    cout<<ans1.x<<" "<<ans1.y<<"\n";
    cout<<ans2.x<<" "<<ans2.y<<"\n";
}
long double xss,xls,yss,yls;
void get_eff()
{
    xss=0;
    xls=0;
    yss=0;
    yls=0;
    for (int i=0;i<m;++i)
    {
        xss+=h[i].x*h[i].x;
        xls+=h[i].x;
        yss+=h[i].y*h[i].y;
        yls+=h[i].y;
    }
    for (int i=0;i<n;++i)
    {
        eff[i]=xss+yss;
        eff[i]-=2*a[i].x*xls+2*a[i].y*yls;
        eff[i]+=m*a[i].x*a[i].x+m*a[i].y*a[i].y;
        bs[round(eff[i])].push_back(i);
        //cerr<<i<<": "<<eff[i]<<endl;
    }
}
long double wd[MAX_N];
long double twd;
long double getAB(int i, int j)
{
    long double a,b,d;
    a=wd[i]-wd[j];
    if (a<0) a=-a;
    b=twd-a;
    d=a-b;
    if (d<0) d=-d;
    return d;
}
void get_wall_dist()
{
    wd[0]=0;
    for (int i=1;i<n;++i)
    {
        wd[i]=wd[i-1]+sqrt((a[i].x-a[i-1].x)*(a[i].x-a[i-1].x)+(a[i].y-a[i-1].y)*(a[i].y-a[i-1].y));
        //cerr<<"wd "<<i<<": "<<wd[i]<<endl;
    }
    twd=wd[n-1]+sqrt((a[0].x-a[n-1].x)*(a[0].x-a[n-1].x)+(a[0].y-a[n-1].y)*(a[0].y-a[n-1].y));
    //cerr<<"twd: "<<twd<<endl;
}
long double mind=-1;
long double cd=-1;
int p1,p2;
int c1,c2;
void find_matching()
{
    auto i=bs.begin();
    for (auto i=bs.begin();i!=bs.end();++i)
    {
        auto &v=i->second;
        //cerr<<"there are "<<v.size()<<" at dist "<<i->first<<endl;
        if (v.size()>1)
        {
            for (int j=0;j<v.size();++j)
            {
                for (int k=j+1;k<v.size();++k)
                {
                    c1=v[j];
                    c2=v[k];
                    //cerr<<c1<<" "<<c2<<" "<<eff[c1]-eff[c2]<<" "<<getAB(c1,c2)<<endl;
                    if (fabs(eff[c1]-eff[c2])<EPS || fabs(eff[c1]-eff[c2])/eff[j]<EPS)
                    {
                        cd=getAB(c1,c2);
                        if (mind==-1 || cd<mind)
                        {
                            p1=c1;
                            p2=c2;
                            mind=cd;
                        }
                    }
                }
            }
        }
    }
    ans1=a[p1];
    ans2=a[p2];
}
void solve()
{
    get_eff();
    get_wall_dist();
    //cerr<<getAB(0,2)<<endl;
    find_matching();
}

int main()
{
    cin.tie(0);
    ios::sync_with_stdio(0);

    input();
    solve();
    output();

    return 0;
}
