#include <iostream>
#include <algorithm>
#include <vector>
#include <cmath>
#include <cstdint>

using namespace std;

struct point
{
    double x, y;
};

double calc_sq_dist (const point &a, const point &b)
{
    double x=a.x-b.x;
    double y=a.y-b.y;
    //cout<<"ASD: "<<a.x<<' '<<a.y<<endl;
    //cout<<"ASD: "<<b.x<<' '<<b.y<<endl;
    //cout<<"DSA: "<<x<<' '<<y<<endl;
    return x*x+y*y;
}

vector < point > ogr, k;
vector < double > prefix_dist;

void init()
{
    //ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    uint32_t n;
    cin>>n;
    ogr.resize(n);
    prefix_dist.resize(n+1);
    prefix_dist[0]=0.0;
    for(uint32_t i=0; i<ogr.size(); i++)
    {
        cin>>ogr[i].x>>ogr[i].y;

    }
    for(uint32_t i=1; i<ogr.size(); i++)
        prefix_dist[i]=prefix_dist[i-1]+calc_sq_dist(ogr[i-1], ogr[i]);
    prefix_dist[ogr.size()]=prefix_dist[ogr.size()-1]
                            +calc_sq_dist(ogr[0], ogr[ogr.size()-1]);

    //for(uint32_t i=0; i<prefix_dist.size(); i++)
    //    cout<<prefix_dist[i]<<' ';
    //cout<<endl;

    cin>>n;
    k.resize(n);
    for(uint32_t i=0; i<k.size(); i++)
        cin>>k[i].x>>k[i].y;
}

double best_diff=99999999999999999999999999999.0;
point best[2];

bool check (const point &a, const point &b)
{
    //cout<<"ASD:"<<a.x<<' '<<a.y<<endl;
    //cout<<"DSA:"<<b.x<<' '<<b.y<<endl;
    double sum_a=0, sum_b=0;
    for(uint32_t i=0; i<k.size(); i++)
    {
        sum_a+=calc_sq_dist(a, k[i]);
        sum_b+=calc_sq_dist(b, k[i]);
    }
    //cout<<sum_a<<' '<<sum_b<<endl;
    if(sum_a==sum_b)return true;
    return false;
}

void check_best (uint32_t id_a, uint32_t id_b)
{
    if(id_a>id_b)swap(id_a, id_b);
    double dist2 = (prefix_dist[id_b] - prefix_dist[id_a]);
    double dist1 = prefix_dist.back() - dist2;
    double diff = dist1-dist2;
    diff=fabs(diff);
    if(diff<best_diff)
    {
        best_diff=diff;
        best[0]=ogr[id_a];
        best[1]=ogr[id_b];
    }
}

int main()
{
    init();
    for(uint32_t i=0; i<ogr.size()-1; i++)
    {
        for(uint32_t j=i+1; j<ogr.size(); j++)
        {
            if(check(ogr[i], ogr[j]))
                check_best(i, j);
        }
    }
    printf("%.6f %.6f\n", best[0].x, best[0].y);
    printf("%.6f %.6f\n", best[1].x, best[1].y);


    return 0;
}
