#include <iostream>
#include <cmath>
#include <cstdio>
using namespace std;

const int MAXN = 1000005;
const double EPS = 0.0000001;

struct Point
{
    double x, y;
};

int n, m;
Point A[MAXN], B[MAXN];
double sum[MAXN], poly = 0;

double dist(Point A, Point B)
{
    double x = A.x - B.x, y = A.y - B.y;
    return x * x + y * y;
}

void Init()
{
    cin >> n;
    for (int i = 1; i <= n; ++ i)
    {
        cin >> A[i].x >> A[i].y;
    }
    cin >> m;
    if (m < 10000)
    {
        for (int i = 1; i <= m; ++ i)
        {
            cin >> B[i].x >> B[i].y;
        }
    }
    else
    {
        int a, b, c, d, p;
        cin >> a >> b >> c >> d >> p;
        B[1].x = a;
        B[1].y = b;
        for (int i = 2; i <= m; ++ i)
        {
            a = (a * c + d) % p;
            b = (b * d + c) % p;
            B[i].x = a;
            B[i].y = b;
        }
    }
}

void Precomp()
{
    for (int i = 1; i <= n; ++ i)
    {
        poly += dist(A[i], A[(i != n) ? i + 1 : 1]);
        for (int j = 1; j <= m; ++ j)
        {
            sum[i] += dist(A[i], B[j]);
        }
    }
}

pair<Point, Point> Solve()
{
    double mindiff = -1, half;
    int p = 0, q = 0, j;

    half = 0; j = 1;
    for (int i = 1; i <= n; ++ i)
    {
        while (true)
        {
            if (i == j)
            {
                half += dist(A[j], A[(j != n) ? j + 1 : 1]);
                j++;
                if (j > n) j = 1;
                continue;
            }

            if ((half + dist(A[j], A[(j != n) ? j + 1 : 1]) * 2 <= poly)
            {
                half += dist(A[j], A[(j != n) ? j + 1 : 1]);
                j++;
                if (j > n) j = 1;
            }
            else break;
        }


        if (fabs(sum[i] - sum[j]) < EPS)
        {
            if (mindiff == -1 or mindiff > fabs(poly - 2 * half))
            {
                mindiff = fabs(poly - 2 * half);
                p = i; q = j;
            }
        }

        half -= dist(A[i], A[(i != n) ? i + 1 : 1]);
    }
    return make_pair(A[p], A[q]);
}

int main()
{
    Init();
    Precomp();
    Solve();

    pair<Point, Point> ans = Solve();
    printf("%.8f %.8f\n", ans.first.x, ans.first.y);
    printf("%.8f %.8f\n", ans.second.x, ans.second.y);
    return 0;
}

/*
4
0 0
0 2
2 2
2 0
1
1 4
*/
