#include <iostream>
#include <cmath>
#include <algorithm>
#include <cstdio>
using namespace std;

const int MAXN = 1000005;
const double EPS = 0.000001;

struct Point
{
    double x, y;
};

int n, m;
Point A[MAXN], B[MAXN];
double sum[MAXN], pol[MAXN];

double dist(Point A, Point B)
{
    double x = A.x - B.x, y = A.y - B.y;
    return x * x + y * y;
}

bool cmp(int x, int y)
{
    return sum[x] < sum[y];
}

void Init()
{
    cin >> n;
    for (int i = 1; i <= n; ++ i)
    {
        cin >> A[i].x >> A[i].y;
    }
    cin >> m;
    if (m < 10000)
    {
        for (int i = 1; i <= m; ++ i)
        {
            cin >> B[i].x >> B[i].y;
        }
    }
    else
    {
        int a, b, c, d, p;
        cin >> a >> b >> c >> d >> p;
        B[1].x = a;
        B[1].y = b;
        for (int i = 2; i <= m; ++ i)
        {
            a = (a * c + d) % p;
            b = (b * d + c) % p;
            B[i].x = a;
            B[i].y = b;
        }
    }
}

void Precomp()
{
    pol[0] = 0;
    for (int i = 1; i <= n; ++ i)
    {
        pol[i] = pol[i - 1] + dist(A[i], A[(i != n) ? i + 1 : 1]);
        for (int j = 1; j <= m; ++ j)
        {
            sum[i] += dist(A[i], B[j]);
        }
    }
}

pair<int, int> Solve()
{
    vector<int> v;
    for (int i = 1; i <= n; ++ i)
    {
        v.push_back(i);
    }
    sort(v.begin(), v.end(), cmp);

    double mindiff = -1;
    int p = 0, q = 0;

    for (int i = 0; i < v.size(); ++ i)
    {
        for (int j = i + 1; j < v.size(); ++ j)
        {
            int pp = v[i], qq = v[j];
            if (sum[qq] - sum[pp] > EPS) break;
            if (pp > qq) swap(pp, qq);
            double half = pol[qq - 1] - pol[pp - 1];
            if (mindiff == -1 or mindiff > fabs(pol[n] - 2 * half))
            {
                mindiff = fabs(pol[n] - 2 * half);
                p = pp; q = qq;
            }
        }
    }

    return make_pair(p, q);
}

int main()
{
    Init();
    Precomp();

    pair<int, int> ans = Solve();
    printf("%.8f %.8f\n", A[ans.first].x, A[ans.first].y);
    printf("%.8f %.8f\n", A[ans.second].x, A[ans.second].x);
    return 0;
}

/*
4
0 0
0 2
2 2
2 0
1
1 4
*/
