#include <iostream>
#include <vector>
#include <stack>
#include <utility>
#include <set>
using namespace std;

const int MAXN = 50005;
const int MAXM = 100005;

int n, m;
vector<int> g[MAXN];
pair<int, int> e[MAXM];
bool use[MAXM];

void Init()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    cin >> n >> m;
    for (int i = 1; i <= m; ++ i)
    {
        int u, v;
        cin >> u >> v;
        if (v > u) swap(u, v);
        e[i].first = u;
        e[i].second = v;
        g[u].push_back(v);
        g[v].push_back(u);
    }
}

int vis[MAXN], siv[MAXN];
vector<int> c[MAXN];
set<pair<int, int>> r;

void DFS(int u)
{
    // cout << u << endl;
    for (int v : g[u])
    {
        if (v == vis[u]) continue;
        if (vis[v] == 0)
        {
            vis[v] = u;
            DFS(v);
            vis[v] = -1;
        }
        if (vis[v] > 0)
        {
            // cout << "found " << v << ":";
            stack<int> s;
            int x = u;
            r.insert(make_pair(u, v));
            while (x != v)
            {
                s.push(x);
                r.insert(make_pair(vis[x], x));
                x = vis[x];
            }
            while (!s.empty())
            {
                // cout << ' ' << s.top();
                c[v].push_back(s.top());
                s.pop();
            }
            // cout << endl;
            c[v].push_back(0);
        }
    }
}

//void FSD(int u)
//{
//    cout << u << endl;
//    for (int v : c[u])
//    {
//        if (v != 0) FSD(v);
//        else cout << u << endl;
//    }
//}

int main()
{
    Init();

    vis[1] = 1;
    DFS(1);

    cout << 1 << endl;

    for (auto rr : r)
    {
        cout << rr.first << ' ' << rr.second << endl;
    }

}
/*
6 7
1 2
2 3
2 4
3 5
3 6
4 5
5 6
----------
5 6
1 2
1 4
2 4
2 3
3 5
2 5
----------
5 7
1 2
2 3
3 4
1 4
3 5
2 5
2 4
*/
